package com.ruoyi.oa.service;

import com.ruoyi.oa.domain.vo.OaProjectReportVo;
import com.ruoyi.oa.domain.bo.OaProjectReportBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.ruoyi.oa.domain.vo.ProjectReportCardVo;
import com.ruoyi.oa.domain.vo.ProjectReportPieVo;
import com.ruoyi.oa.domain.vo.ProjectReportTrendVo;

import java.time.LocalDate;
import java.util.Collection;
import java.util.List;

/**
 * 项目报工Service接口
 *
 * @author hdka
 * @date 2025-06-16
 */
public interface IOaProjectReportService {

    /**
     * 查询项目报工
     */
    OaProjectReportVo queryById(Long reportId);

    /**
     * 查询项目报工列表
     */
    TableDataInfo<OaProjectReportVo> queryPageList(OaProjectReportBo bo, PageQuery pageQuery);

    /**
     * 查询项目报工列表
     */
    List<OaProjectReportVo> queryList(OaProjectReportBo bo);

    /**
     * 新增项目报工
     */
    Boolean insertByBo(OaProjectReportBo bo);

    /**
     * 修改项目报工
     */
    Boolean updateByBo(OaProjectReportBo bo);

    /**
     * 校验并批量删除项目报工信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 报工数据看板
     * @return
     */
    ProjectReportCardVo getCardData();

    public List<ProjectReportTrendVo> getTrend(LocalDate start, LocalDate end);

    public List<ProjectReportPieVo> getDistribution(LocalDate start, LocalDate end);


    List<OaProjectReportVo> getRankData(LocalDate start, LocalDate end);

    List<OaProjectReportVo> getProjects(LocalDate start, LocalDate end);

    List<OaProjectReportVo> clearList(LocalDate start, LocalDate end);

    List<OaProjectReportVo> getSummaryData(LocalDate start, LocalDate end);
}
